import numpy as np

# Преобразования символа в вектор для кодирования
def encode_char(c):
    assert(ord(c)<128)
    return [list(int(i) for i in (bin(ord(c))[2:]).rjust(7,"0"))]

# Преобразование вектора в символ после декодирования
def decode_char(c):
    result = 0
    for i in c[0]:
        result = (result << 1) + i
    return chr(result)

# Порождающая матрица (кодирующая)
G = np.array([[1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0],
[0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0],
[0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0],
[0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0],
[0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0],
[0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1, 0],
[0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 1]])

# Проверяющая матрица
H = np.array([[1,0,0,0,1,0,1,1,0,0,0,0,0,0,0],
[0,1,0,0,0,1,0,1,1,0,0,0,0,0,0],
[0,0,1,0,0,0,1,0,1,1,0,0,0,0,0],
[0,0,0,1,0,0,0,1,0,1,1,0,0,0,0],
[0,0,0,0,1,0,0,0,1,0,1,1,0,0,0],
[0,0,0,0,0,1,0,0,0,1,0,1,1,0,0],
[0,0,0,0,0,0,1,0,0,0,1,0,1,1,0],
[0,0,0,0,0,0,0,1,0,0,0,1,0,1,1]])

# G^-1 (декодирующая матрица)
G_inv = np.array([[0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [0, 0, 0, 0, 0, 0, 0],
 [1, 0, 0, 0, 0, 0, 0],
 [0, 1, 0, 0, 0, 0, 0],
 [0, 0, 1, 0, 0, 0, 0],
 [0, 0, 0, 1, 0, 0, 0],
 [1, 0, 0, 0, 1, 0, 0],
 [0, 1, 0, 0, 0, 1, 0],
 [1, 0, 1, 0, 0, 0, 1]])

# Векторы ошибок
E1 = [0,0,0,0,0,0,0,0,0,0,0,0,0,1,0]
E2 = [0,0,0,0,0,0,0,0,0,0,0,0,1,0,0]
E3 = [0,0,0,0,0,0,0,0,0,0,0,0,1,1,0]

# Пример работы БЧХ кода
print("encode_char(\"d\") \t\t\t",encode_char("d"))
print("decode_char(encode_char(\"d\")) \t\t",decode_char(encode_char("d")))
print("encode_char(\"d\")@G%2 \t\t\t",encode_char("d")@G%2)
print("(encode_char(\"d\")@G%2)@H.T%2 \t\t",(encode_char("d")@G%2)@H.T%2)
print("((encode_char(\"d\")@G%2+E1)%2)@H.T%2 \t",((encode_char("d")@G%2+E1)%2)@H.T%2)
print("((encode_char(\"d\")@G%2+E2)%2)@H.T%2 \t",((encode_char("d")@G%2+E2)%2)@H.T%2)
print("((encode_char(\"d\")@G%2+E3)%2)@H.T%2 \t",((encode_char("d")@G%2+E3)%2)@H.T%2)
print("(encode_char(\"d\")@G%2)@G_inv%2 \t\t",(encode_char("d")@G%2)@G_inv%2)
print("decode_char((encode_char(\"d\")@G%2)@G_inv%2) \t\t",decode_char((encode_char("d")@G%2)@G_inv%2))